/*******************************************************************************
 * Copyright (c) 2008 itemis AG (http://www.itemis.eu) and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *******************************************************************************/
package org.eclipse.xtext.linking;

import java.util.List;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.xtext.linking.impl.IllegalNodeException;
import org.eclipse.xtext.nodemodel.INode;

/**
 * @author Heiko Behrens - Initial contribution and API
 * @author Sebastian Zarnekow
 */
public interface ILinkingService {

	/**
	 * Returns all {@link EObject}s referenced by the given link text in the
	 * given context. But does not set the references or modifies the passed
	 * information somehow. The returned list might contain proxy instances.
	 */
	List<EObject> getLinkedObjects(EObject context, EReference reference, INode node) throws IllegalNodeException;
}
